missed closing bracket when substituting kargs for serial.
[bootcd.git] / build.sh
index b76019c..763f0be 100755 (executable)
--- a/build.sh
+++ b/build.sh
 #!/bin/bash
+#
+# Builds custom BootCD ISO and USB images in the current
+# directory. 
+#
+# Aaron Klingaman <alk@absarokasoft.com>
+# Mark Huang <mlhuang@cs.princeton.edu>
+# Copyright (C) 2004-2007 The Trustees of Princeton University
+#
+# $Id$
+#
+
+PATH=/sbin:/bin:/usr/sbin:/usr/bin
+
+CONFIGURATION=default
+NODE_CONFIGURATION_FILE=
+DEFAULT_TYPES="usb iso"
+# Leave 4 MB of free space
+FREE_SPACE=4096
+CUSTOM_DIR=
+OUTPUT_BASE=
+GRAPHIC_CONSOLE="graphic"
+SERIAL_CONSOLE="ttyS0:115200:n:8"
+CONSOLE_INFO=$GRAPHIC_CONSOLE
+MKISOFS_OPTS="-R -J -r -f -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table"
+
+ALL_TYPES=""
+for x in iso usb usb_partition; do for s in "" "_serial" ; do for c in "" "_cramfs" ; do
+  t="${x}${c}${s}"
+  case $t in
+      usb_partition_cramfs|usb_partition_cramfs_serial)
+         # unsupported
+         ;;
+      *)
+         ALL_TYPES="$ALL_TYPES $t" ;;
+  esac
+done; done; done
+
+# NOTE
+# the custom-dir feature is designed to let a myplc try/ship a patched bootcd
+# without the need for a full devel environment
+# for example, you would create /root/custom-bootcd/etc/rc.d/init.d/pl_hwinit
+# and run this script with -C /root/custom-bootcd
+# this creates a third .img image of the custom dir, that 'hides' the files from 
+# bootcd.img in the resulting unionfs
+# it seems that this feature has not been used nor tested in a long time, use with care
+usage()
+{
+    echo "Usage: build.sh [OPTION]..."
+    echo "    -f plnode.txt    Node to customize CD for (default: none)"
+    echo "    -t 'types'       Build the specified images (default: $DEFAULT_TYPES)"
+    echo "    -a               Build all known types as listed below"
+    echo "    -s console-info  Enable a serial line as console and also bring up getty on that line"
+    echo "                     console-info: tty:baud-rate:parity:bits"
+    echo "                     or 'default' shortcut for $SERIAL_CONSOLE"
+    echo "                     Using this is recommended, rather than mentioning 'serial' in a type"
+    echo "    -O output-base   The prefix of the generated files (default: PLC_NAME-BootCD-VERSION)"
+    echo "                     useful when multiple types are provided"
+    echo "                     can be a full path"
+    echo "    -o output-name   The full name of the generated file"
+    echo "    -C custom-dir    Custom directory"
+    echo "    -n               Dry run - mostly for debug/test purposes"
+    echo "    -h               This message"
+    echo "All known types: $ALL_TYPES"
+    exit 1
+}
+
+# init
+TYPES=""
+# Get options
+while getopts "f:t:as:O:o:C:nh" opt ; do
+    case $opt in
+    f)
+        NODE_CONFIGURATION_FILE=$OPTARG ;;
+    t)
+        TYPES="$TYPES $OPTARG" ;;
+    a)
+        TYPES="$ALL_TYPES" ;;
+    s)
+        CONSOLE_INFO="$OPTARG" 
+       [ "$CONSOLE_INFO" == "default" ] && CONSOLE_INFO=$SERIAL_CONSOLE
+       ;;
+    O)
+        OUTPUT_BASE="$OPTARG" ;;
+    o)
+        OUTPUT_NAME="$OPTARG" ;;
+    C)
+        CUSTOM_DIR="$OPTARG" ;;
+    n)
+       DRY_RUN=true ;;
+    h|*)
+        usage ;;
+    esac
+done
 
+# use default if not set
+[ -z "$TYPES" ] && TYPES="$DEFAULT_TYPES"
+
+# Do not tolerate errors
 set -e
 
-# where the boot cd build config files are stored (and certificats/keys)
-CONFIGURATIONS_DIR=configurations/
+# Change to our source directory
+srcdir=$(cd $(dirname $0) && pwd -P)
+pushd $srcdir
 
-# where built files are stored
-BUILD_DIR=build/
+# Root of the isofs
+isofs=$PWD/build/isofs
 
-BOOTCD_VERSION="3.2"
-FULL_VERSION_STRING="PlanetLab BootCD"
-OUTPUT_IMAGE_NAME='PlanetLab-BootCD'
-    
-SYSLINUX_SRC=sources/syslinux-2.11.tar.bz2
+# The reference image is expected to have been built by prep.sh (see .spec)
+# we disable the initial logic that called prep.sh if that was not the case
+# this is because prep.sh needs to know pldistro 
+if [ ! -f $isofs/bootcd.img -o ! -f build/version.txt ] ; then
+    echo "You have to run prep.sh prior to calling $0 - exiting"
+    exit 1
+fi
 
-BOOTCD_YUM_GROUP=BootCD
+# build/version.txt written by prep.sh
+BOOTCD_VERSION=$(cat build/version.txt)
 
-CDRECORD_FLAGS="-v -dao"
+if [ -f /etc/planetlab/plc_config ] ; then
+    # Source PLC configuration
+    . /etc/planetlab/plc_config
+fi
 
-CONF_FILES_DIR=conf_files/
+FULL_VERSION_STRING="${PLC_NAME} BootCD ${BOOTCD_VERSION}"
+
+echo "* Building images for $FULL_VERSION_STRING"
+
+# From within a myplc chroot /usr/tmp is too small 
+# to build all possible images, whereas /data is part of the host
+# filesystem and usually has sufficient space.  What we
+# should do is check whether the expected amount of space
+# is available.
+BUILDTMP=/usr/tmp
+if [ -d /data/tmp ] ; then
+    isreadonly=$(mktemp /data/tmp/isreadonly.XXXXXX || /bin/true)
+    if [ -n "$isreadonly" ] ; then
+        rm -f "$isreadonly"
+        BUILDTMP=/data/tmp
+    fi
+fi
 
-# size of the ram disk in MB
-RAMDISK_SIZE=64
+declare -a _CLEANUPS=()
+function do_cleanup()
+{
+    cd /
+    for i in "${_CLEANUPS[@]}"; do
+        $i
+    done
+}
+function push_cleanup()
+{
+    _CLEANUPS=( "${_CLEANUPS[@]}" "$*" )
+}
+function pop_cleanup()
+{
+    unset _CLEANUPS[$((${#_CLEANUPS[@]} - 1))]
+}
 
-# the bytes per inode ratio (the -i value in mkfs.ext2) for the ramdisk
-INITRD_BYTES_PER_INODE=1024
+trap "do_cleanup" ERR INT EXIT
 
+BUILDTMP=$(mktemp -d ${BUILDTMP}/bootcd.XXXXXX)
+push_cleanup rm -fr "${BUILDTMP}"
+mkdir "${BUILDTMP}/isofs"
+for i in "$isofs"/{bootcd.img,kernel}; do
+    ln -s "$i" "${BUILDTMP}/isofs"
+done
+cp "/usr/lib/syslinux/isolinux.bin" "${BUILDTMP}/isofs"
+isofs="${BUILDTMP}/isofs"
+
+# Root of the ISO and USB images
+echo "* Populating root filesystem..."
+overlay="${BUILDTMP}/overlay"
+install -d -m 755 $overlay
+push_cleanup rm -fr $overlay
+
+# Create version files
+echo "* Creating version files"
+
+# Boot Manager compares pl_version in both places to make sure that
+# the right CD is mounted. We used to boot from an initrd and mount
+# the CD on /usr. Now we just run everything out of the initrd.
+for file in $overlay/pl_version $overlay/usr/isolinux/pl_version ; do
+    mkdir -p $(dirname $file)
+    echo "$FULL_VERSION_STRING" >$file
+done
 
-# make sure the boot manager source is checked out in the same directory
-# as the bootcd_v3 repository
-for BOOTMANAGER_DIR in ../bootmanager-* ../bootmanager ; do
-    [ -d $BOOTMANAGER_DIR ] && break
+# Install boot server configuration files
+echo "* Installing boot server configuration files"
+
+# We always intended to bring up and support backup boot servers,
+# but never got around to it. Just install the same parameters for
+# both for now.
+for dir in $overlay/usr/boot $overlay/usr/boot/backup ; do
+    install -D -m 644 $PLC_BOOT_CA_SSL_CRT $dir/cacert.pem
+    install -D -m 644 $PLC_ROOT_GPG_KEY_PUB $dir/pubring.gpg
+    echo "$PLC_BOOT_HOST" >$dir/boot_server
+    echo "$PLC_BOOT_SSL_PORT" >$dir/boot_server_port
+    echo "/boot/" >$dir/boot_server_path
 done
 
-if [ ! -d $BOOTMANAGER_DIR ]; then
-    echo "the bootmanager repository needs to be checked out at the same"
-    echo "level as this directory, for the merge_hw_tables.py script"
-    exit
+# Install old-style boot server configuration files
+# as opposed to what a former comment suggested, 
+# this is still required, somewhere in the bootmanager apparently
+install -D -m 644 $PLC_BOOT_CA_SSL_CRT $overlay/usr/bootme/cacert/$PLC_BOOT_HOST/cacert.pem
+echo "$FULL_VERSION_STRING" >$overlay/usr/bootme/ID
+echo "$PLC_BOOT_HOST" >$overlay/usr/bootme/BOOTSERVER
+echo "$PLC_BOOT_HOST" >$overlay/usr/bootme/BOOTSERVER_IP
+echo "$PLC_BOOT_SSL_PORT" >$overlay/usr/bootme/BOOTPORT
+
+# Generate /etc/issue
+echo "* Generating /etc/issue"
+
+if [ "$PLC_WWW_PORT" = "443" ] ; then
+    PLC_WWW_URL="https://$PLC_WWW_HOST/"
+elif [ "$PLC_WWW_PORT" != "80" ] ; then
+    PLC_WWW_URL="http://$PLC_WWW_HOST:$PLC_WWW_PORT/"
+else
+    PLC_WWW_URL="http://$PLC_WWW_HOST/"
+fi
+
+mkdir -p $overlay/etc
+cat >$overlay/etc/issue <<EOF
+$FULL_VERSION_STRING
+$PLC_NAME Node: \n
+Kernel \r on an \m
+$PLC_WWW_URL
+
+This machine is a node in the $PLC_NAME distributed network.  It has
+not fully booted yet. If you have cancelled the boot process at the
+request of $PLC_NAME Support, please follow the instructions provided
+to you. Otherwise, please contact $PLC_MAIL_SUPPORT_ADDRESS.
+
+Console login at this point is restricted to root. Provide the root
+password of the default $PLC_NAME Central administrator account at the
+time that this CD was created.
+
+EOF
+
+# Set root password
+echo "* Setting root password"
+
+if [ -z "$ROOT_PASSWORD" ] ; then
+    # Generate an encrypted password with crypt() if not defined
+    # in a static configuration.
+    ROOT_PASSWORD=$(python <<EOF
+import crypt, random, string
+salt = [random.choice(string.letters + string.digits + "./") for i in range(0,8)]
+print crypt.crypt('$PLC_ROOT_PASSWORD', '\$1\$' + "".join(salt) + '\$')
+EOF
+)
 fi
 
+# build/passwd copied out by prep.sh
+sed -e "s@^root:[^:]*:\(.*\)@root:$ROOT_PASSWORD:\1@" build/passwd \
+    >$overlay/etc/passwd
+
+# Install node configuration file (e.g., if node has no floppy disk or USB slot)
+if [ -f "$NODE_CONFIGURATION_FILE" ] ; then
+    echo "* Installing node configuration file $NODE_CONFIGURATION_FILE -> /usr/boot/plnode.txt of the bootcd image"
+    install -D -m 644 $NODE_CONFIGURATION_FILE $overlay/usr/boot/plnode.txt
+fi
+
+# Pack overlay files into a compressed archive
+echo "* Compressing overlay image"
+(cd $overlay && find . | cpio --quiet -c -o) | gzip -9 >$isofs/overlay.img
+
+rm -rf $overlay
+pop_cleanup
+
+if [ -n "$CUSTOM_DIR" ]; then
+    echo "* Compressing custom image"
+    (cd "$CUSTOM_DIR" && find . | cpio --quiet -c -o) | gzip -9 >$isofs/custom.img
+fi
+
+# Calculate ramdisk size (total uncompressed size of both archives)
+ramdisk_size=$(gzip -l $isofs/bootcd.img $isofs/overlay.img ${CUSTOM_DIR:+$isofs/custom.img} | tail -1 | awk '{ print $2; }') # bytes
+ramdisk_size=$((($ramdisk_size + 1023) / 1024)) # kilobytes
+
+echo "$FULL_VERSION_STRING" >$isofs/pl_version
+
+popd
+
+function extract_console_dev()
+{
+    local console="$1"
+    dev=$(echo $console| awk -F: ' {print $1}')
+    echo $dev
+}
 
-function usage()
+function extract_console_baud()
 {
-    echo "Usage: build.sh <action> [<configuration>]"
-    echo "Action: build burn clean"
-    echo
-    echo "If configuration is missing, 'default' is loaded"
-    exit
+    local console="$1"
+    baud=$(echo $console| awk -F: ' {print $2}')
+    [ -z "$baud" ] && baud="115200"
+    echo $baud
 }
 
+function extract_console_parity()
+{
+    local console="$1"
+    parity=$(echo $console| awk -F: ' {print $3}')
+    [ -z "$parity" ] && parity="n"
+    echo $parity
+}
+
+function extract_console_bits()
+{
+    local console="$1"
+    bits=$(echo $console| awk -F: ' {print $4}')
+    [ -z "$bits" ] && bits="8"
+    echo $bits
+}
 
-function build_cdroot()
+function build_iso()
 {
-    if [ -f $CD_ROOT/.built ]; then
-       echo "cd root already built, skipping"
-       return
+    local iso="$1" ; shift
+    local console="$1" ; shift
+    local custom="$1"
+    local serial=
+
+    if [ "$console" != "$GRAPHIC_CONSOLE" ] ; then
+       serial=1
+       console_dev=$(extract_console_dev $console)
+       console_baud=$(extract_console_baud $console)
+       console_parity=$(extract_console_parity $console)
+       console_bits=$(extract_console_bits $console)
     fi
 
-    clean
-    
-    mkdir -p $CD_ROOT/dev/pts
-    mkdir -p $CD_ROOT/proc
-    mkdir -p $CD_ROOT/etc
-
-    echo "copy fstab and mtab"
-    cp -f $CONF_FILES_DIR/fstab $CD_ROOT/etc/
-    cp -f $CONF_FILES_DIR/mtab $CD_ROOT/etc/
-
-    echo "setup rpm to install only en_US locale and no docs"
-    mkdir -p $CD_ROOT/etc/rpm
-    cp -f $CONF_FILES_DIR/macros $CD_ROOT/etc/rpm
-    # trick rpm and yum
-    export HOME=$PWD
-    cp -f $CONF_FILES_DIR/macros $PWD/.rpmmacros
-
-    echo "initialize rpm db"
-    mkdir -p $CD_ROOT/var/lib/rpm
-    rpm --root $CD_ROOT --initdb
-    
-    # XXX Should download yum.conf from the boot server?
-    echo "generate yum.conf"
-cat >yum.conf <<EOF
-[main]
-cachedir=/var/cache/yum
-debuglevel=2
-logfile=/var/log/yum.log
-pkgpolicy=newest
-### for yum-2.4 in fc4 (this will be ignored by yum-2.0)
-### everything in here, do not scan /etc/yum.repos.d/
-reposdir=/dev/null
-
-[FedoraCore2Base]
-name=Fedora Core 2 Base -- PlanetLab Central
-baseurl=http://$PRIMARY_SERVER/install-rpms/stock-fc2/
-
-[FedoraCore2Updates]
-name=Fedora Core 2 Updates -- PlanetLab Central
-baseurl=http://$PRIMARY_SERVER/install-rpms/updates-fc2/
-
-[PlanetLab]
-name=PlanetLab RPMS -- PlanetLab Central
-baseurl=http://$PRIMARY_SERVER/install-rpms/planetlab/
+    # Write isolinux configuration
+    cat >$isofs/isolinux.cfg <<EOF
+${serial:+SERIAL 0 ${console_baud}}
+DEFAULT kernel
+APPEND ramdisk_size=$ramdisk_size initrd=bootcd.img,overlay.img${custom:+,custom.img} root=/dev/ram0 rw ${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
+DISPLAY pl_version
+PROMPT 0
+TIMEOUT 40
 EOF
-    yumgroups="http://$PRIMARY_SERVER/install-rpms/planetlab/yumgroups.xml"
-
-   # Solve the bootstrap problem by including any just built packages in
-   # the yum configuration. This cooperates with the PlanetLab build
-   # system.
-   if [ -n "$RPM_BUILD_DIR" ] ; then
-       cat >>yum.conf <<EOF
-[Bootstrap]
-name=Bootstrap RPMS -- $(dirname $RPM_BUILD_DIR)/RPMS/
-baseurl=file://$(dirname $RPM_BUILD_DIR)/RPMS/
+
+    # write kargs.txt with additional args that should be executed by kexec to production mode
+    cat >$isofs/kargs.txt <<EOF
+${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
 EOF
-       yumgroups="file://$(dirname $RPM_BUILD_DIR)/RPMS/yumgroups.xml"
-   fi
-
-    echo "install boot cd base rpms"
-    yum -c yum.conf --installroot=$CD_ROOT -y groupinstall $BOOTCD_YUM_GROUP
-
-    # Retrieve all of the packagereq declarations in the BootCD group of the yumgroups.xml file
-    echo "checking to make sure rpms were installed"
-    packages=$(curl $yumgroups | sed -n -e '/<name>BootCD<\/name>/,/<name>/{ s/.*<packagereq.*>\(.*\)<\/packagereq>/\1/p }')
-    set +e
-    for package in $packages; do
-       echo "checking for package $package"
-       /usr/sbin/chroot $CD_ROOT /bin/rpm -qi $package > /dev/null
-       if [[ "$?" -ne 0 ]]; then
-           echo "package $package was not installed in the cd root."
-           echo "make sure it exists in the yum repository."
-           exit 1
-       fi
-    done
-    set -e
-    
-    echo "removing unneccessary build files"
-    (cd $CD_ROOT/lib/modules && \
-       find ./ -type d -name build -maxdepth 2 -exec rm -rf {} \;)
-
-    echo "setting up non-ssh authentication"
-    mkdir -p $CD_ROOT/etc/samba
-    /usr/sbin/chroot $CD_ROOT /usr/sbin/authconfig --nostart --kickstart \
-       --enablemd5 --enableshadow
-
-    echo "setting root password"
-    sed -i "s#root::#root:$ROOT_PASSWORD:#g" $CD_ROOT/etc/shadow
-
-    echo "relocate some large directories out of the root system"
-    # get /var/lib/rpm out, its 12mb. create in its place a 
-    # symbolic link to /usr/relocated/var/lib/rpm
-    mkdir -p $CD_ROOT/usr/relocated/var/lib/
-    mv $CD_ROOT/var/lib/rpm $CD_ROOT/usr/relocated/var/lib/
-    (cd $CD_ROOT/var/lib && ln -s ../../usr/relocated/var/lib/rpm rpm)
-
-    # get /var/cache/yum out, its 100Mb. create in its place a 
-    # symbolic link to /usr/relocated/var/cache/yum
-    mkdir -p $CD_ROOT/usr/relocated/var/cache/
-    mv $CD_ROOT/var/cache/yum $CD_ROOT/usr/relocated/var/cache/
-    (cd $CD_ROOT/var/cache && ln -s ../../usr/relocated/var/cache/yum yum)
-
-    # get /lib/tls out
-    mkdir -p $CD_ROOT/usr/relocated/lib
-    mv $CD_ROOT/lib/tls $CD_ROOT/usr/relocated/lib/
-    (cd $CD_ROOT/lib && ln -s ../usr/relocated/lib/tls tls)
-
-    echo "extracting syslinux, copying isolinux files to cd"
-    mkdir -p $CD_ROOT/usr/isolinux/
-    mkdir -p $BUILD_DIR/syslinux
-    tar -C $BUILD_DIR/syslinux -xjvf $SYSLINUX_SRC
-    find $BUILD_DIR/syslinux -name isolinux.bin \
-       -exec cp -f {} $CD_ROOT/usr/isolinux/ \;
-
-    echo "moving kernel to isolinux directory"
-    KERNEL=$CD_ROOT/boot/vmlinuz-*
-    mv -f $KERNEL $CD_ROOT/usr/isolinux/kernel
-
-    echo "moving /usr/bin/find and /usr/bin/dirname to /bin"
-    mv $CD_ROOT/usr/bin/find $CD_ROOT/bin/
-    mv $CD_ROOT/usr/bin/dirname $CD_ROOT/bin/
-
-    echo "creating version files"
-    echo "$FULL_VERSION_STRING" > $CD_ROOT/usr/isolinux/pl_version
-    echo "$FULL_VERSION_STRING" > $CD_ROOT/pl_version
-
-    touch $CD_ROOT/.built
+
+    # Create ISO image
+    echo "* Creating ISO image"
+    mkisofs -o "$iso" \
+        $MKISOFS_OPTS \
+        $isofs
 }
 
-function build_initrd()
+function build_usb_partition()
 {
-    echo "building initrd"
-    rm -f $INITRD
-    rm -f $INITRD.gz
-
-    echo "copy fstab and mtab"
-    cp -f $CONF_FILES_DIR/fstab $CD_ROOT/etc/
-    cp -f $CONF_FILES_DIR/mtab $CD_ROOT/etc/
-
-    echo "installing generic modprobe.conf"
-    cp -f $CONF_FILES_DIR/modprobe.conf $CD_ROOT/etc/
-
-    echo "installing our own inittab and init scripts"
-    cp -f $CONF_FILES_DIR/inittab $CD_ROOT/etc
-    init_scripts="pl_sysinit pl_hwinit pl_netinit pl_validateconf pl_boot"
-    for script in $init_scripts; do
-       cp -f $CONF_FILES_DIR/$script $CD_ROOT/etc/init.d/
-       chmod +x $CD_ROOT/etc/init.d/$script
-    done
-
-    echo "setup basic networking files"
-    cp -f $CONF_FILES_DIR/hosts $CD_ROOT/etc/
-
-    echo "copying sysctl.conf (fix tcp window scaling and broken routers)"
-    cp -f $CONF_FILES_DIR/sysctl.conf $CD_ROOT/etc/
-
-    echo "setup default network conf file"
-    mkdir -p $CD_ROOT/usr/boot
-    cp -f $CONF_FILES_DIR/default-net.cnf $CD_ROOT/usr/boot/
-
-    echo "setup boot server configuration"
-    cp -f $CURRENT_CONFIG_DIR/$PRIMARY_SERVER_CERT $CD_ROOT/usr/boot/cacert.pem
-    cp -f $CURRENT_CONFIG_DIR/$PRIMARY_SERVER_GPG $CD_ROOT/usr/boot/pubring.gpg
-    echo "$PRIMARY_SERVER" > $CD_ROOT/usr/boot/boot_server
-    echo "$PRIMARY_SERVER_PORT" > $CD_ROOT/usr/boot/boot_server_port
-    echo "$PRIMARY_SERVER_PATH" > $CD_ROOT/usr/boot/boot_server_path
-
-    echo "setup backup boot server configuration"
-    mkdir -p $CD_ROOT/usr/boot/backup
-    cp -f $CURRENT_CONFIG_DIR/$BACKUP_SERVER_CERT \
-       $CD_ROOT/usr/boot/backup/cacert.pem
-    cp -f $CURRENT_CONFIG_DIR/$BACKUP_SERVER_GPG \
-       $CD_ROOT/usr/boot/backup/pubring.gpg
-    echo "$BACKUP_SERVER" > $CD_ROOT/usr/boot/backup/boot_server
-    echo "$BACKUP_SERVER_PORT" > $CD_ROOT/usr/boot/backup/boot_server_port
-    echo "$BACKUP_SERVER_PATH" > $CD_ROOT/usr/boot/backup/boot_server_path
-
-    echo "copying old boot cd directory bootme (TEMPORARY)"
-    cp -r bootme_old $CD_ROOT/usr/bootme
-    echo "$FULL_VERSION_STRING" > $CD_ROOT/usr/bootme/ID
-    echo "$PRIMARY_SERVER" > $CD_ROOT/usr/bootme/BOOTSERVER
-    echo "$PRIMARY_SERVER" > $CD_ROOT/usr/bootme/BOOTSERVER_IP
-    echo "$PRIMARY_SERVER_PORT" > $CD_ROOT/usr/bootme/BOOTPORT
-
-    echo "copying cacert to old boot cd directory bootme (TEMPORARY)"
-    mkdir -p $CD_ROOT/usr/bootme/cacert/$PRIMARY_SERVER/
-    cp -f $CURRENT_CONFIG_DIR/$PRIMARY_SERVER_CERT \
-       $CD_ROOT/usr/bootme/cacert/$PRIMARY_SERVER/cacert.pem
-
-    echo "forcing lvm to make lvm1 partitions (TEMPORARY)"
-    cp -f $CONF_FILES_DIR/lvm.conf $CD_ROOT/etc/lvm/
-
-    echo "copying isolinux configuration files"
-    cp -f $CONF_FILES_DIR/isolinux.cfg $CD_ROOT/usr/isolinux/
-    echo "$FULL_VERSION_STRING" > $CD_ROOT/usr/isolinux/message.txt
-
-    echo "writing /etc/issue"
-    echo "$FULL_VERSION_STRING" > $CD_ROOT/etc/issue
-    echo "Kernel \r on an \m" >> $CD_ROOT/etc/issue
-    echo "" >> $CD_ROOT/etc/issue
-    echo "" >> $CD_ROOT/etc/issue
-
-    if [[ ! -z "$NODE_CONFIGURATION_FILE" ]]; then
-       echo "Copying node configuration file to cd"
-       cp -f $CURRENT_CONFIG_DIR/$NODE_CONFIGURATION_FILE \
-           $CD_ROOT/usr/boot/plnode.txt
+    echo -n "* Creating USB image with partitions..."
+    local usb="$1" ; shift
+    local console="$1" ; shift
+    local custom="$1"
+    local serial=
+
+    if [ "$console" != "$GRAPHIC_CONSOLE" ] ; then
+       serial=1
+       console_dev=$(extract_console_dev $console)
+       console_baud=$(extract_console_baud $console)
+       console_parity=$(extract_console_parity $console)
+       console_bits=$(extract_console_bits $console)
     fi
 
-    echo "making the isolinux initrd kernel command line match rd size"
-    let INITRD_SIZE_KB=$(($RAMDISK_SIZE * 1024))
-    sed -i "s#ramdisk_size=0#ramdisk_size=$INITRD_SIZE_KB#g" \
-       $CD_ROOT/usr/isolinux/isolinux.cfg
-
-    echo "building pcitable for hardware detection"
-    pci_map_file=`find $CD_ROOT/lib/modules/ -name modules.pcimap | head -1`
-    module_dep_file=`find $CD_ROOT/lib/modules/ -name modules.dep | head -1`
-    pci_table=$CD_ROOT/usr/share/hwdata/pcitable
-    $BOOTMANAGER_DIR/source/merge_hw_tables.py \
-       $module_dep_file $pci_map_file $pci_table $CD_ROOT/etc/pl_pcitable
-
-    dd if=/dev/zero of=$INITRD bs=1M count=$RAMDISK_SIZE
-    /sbin/mkfs.ext2 -F -m 0 -i $INITRD_BYTES_PER_INODE $INITRD
-    mkdir -p $INITRD_MOUNT
-    mount -o loop,rw $INITRD $INITRD_MOUNT
-
-    echo "copy all files except usr to ramdisk"
-    pushd .
-    cd $CD_ROOT
-    find . -path ./usr -prune -o -print | cpio -p -d -u $INITRD_MOUNT
-    popd
+    local size=$(($(du -Lsk $isofs | awk '{ print $1; }') + $FREE_SPACE))
+    size=$(( $size / 1024 ))
 
-    umount $INITRD_MOUNT
-    rmdir $INITRD_MOUNT
+    local heads=64
+    local sectors=32
+    local cylinders=$(( ($size*1024*2)/($heads*$sectors) ))
+    local offset=$(( $sectors*512 ))
+
+    /usr/lib/syslinux/mkdiskimage -M -4 "$usb" $size $heads $sectors
     
-    echo "compressing ramdisk"
-    gzip $INITRD
+    cat >${BUILDTMP}/mtools.conf<<EOF
+drive z:
+file="${usb}"
+cylinders=$cylinders
+heads=$heads
+sectors=$sectors
+offset=$offset
+mformat_only
+EOF
+    # environment variable for mtools
+    export MTOOLSRC="${BUILDTMP}/mtools.conf"
+
+    ### COPIED FROM build_usb() below!!!!
+    echo -n " populating USB image... "
+    mcopy -bsQ -i "$usb" "$isofs"/* z:/
+       
+    # Use syslinux instead of isolinux to make the image bootable
+    tmp="${BUILDTMP}/syslinux.cfg"
+    cat >$tmp <<EOF
+${serial:+SERIAL 0 ${console_baud}}
+DEFAULT kernel
+APPEND ramdisk_size=$ramdisk_size initrd=bootcd.img,overlay.img${custom:+,custom.img} root=/dev/ram0 rw ${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
+DISPLAY pl_version
+PROMPT 0
+TIMEOUT 40
+EOF
+    mdel -i "$usb" z:/isolinux.cfg 2>/dev/null || :
+    mcopy -i "$usb" "$tmp" z:/syslinux.cfg
+    rm -f "$tmp"
+    rm -f "${BUILDTMP}/mtools.conf"
+    unset MTOOLSRC
+
+    echo "making USB image bootable."
+    syslinux -o $offset "$usb"
+
 }
 
-function build()
+# Create USB image
+function build_usb()
 {
-    # build base image via yum
-    build_cdroot
+    echo -n "* Creating USB image... "
+    local usb="$1" ; shift
+    local console="$1" ; shift
+    local custom="$1"
+    local serial=
+
+    if [ "$console" != "$GRAPHIC_CONSOLE" ] ; then
+       serial=1
+       console_dev=$(extract_console_dev $console)
+       console_baud=$(extract_console_baud $console)
+       console_parity=$(extract_console_parity $console)
+       console_bits=$(extract_console_bits $console)
+    fi
 
-    # always build/rebuild initrd
-    build_initrd
+    mkfs.vfat -C "$usb" $(($(du -Lsk $isofs | awk '{ print $1; }') + $FREE_SPACE))
 
-    # build iso image
-    rm -f $ISO
-    mkisofs -o $ISO -R -allow-leading-dots -J -r -b isolinux/isolinux.bin \
-       -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table \
-       $CD_ROOT/usr
+    # write kargs.txt with additional args that should be executed by kexec to production mode
+    tmp="${BUILDTMP}/kargs.txt"
+    cat >$tmp <<EOF
+${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
+EOF
+    mcopy -i "$usb" "$tmp" ::/kargs.txt
+    rm -f "$tmp"
+
+    # Populate it
+    echo -n " populating USB image... "
+    mcopy -bsQ -i "$usb" "$isofs"/* ::/
+
+    # Use syslinux instead of isolinux to make the image bootable
+    tmp="${BUILDTMP}/syslinux.cfg"
+    cat >$tmp <<EOF
+${serial:+SERIAL 0 $console_baud}
+DEFAULT kernel
+APPEND ramdisk_size=$ramdisk_size initrd=bootcd.img,overlay.img${custom:+,custom.img} root=/dev/ram0 rw ${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
+DISPLAY pl_version
+PROMPT 0
+TIMEOUT 40
+EOF
+    mdel -i "$usb" ::/isolinux.cfg 2>/dev/null || :
+    mcopy -i "$usb" "$tmp" ::/syslinux.cfg
+    rm -f "$tmp"
 
-    # build usb image and make it bootable with syslinux (instead of isolinux)
-    USB_IMAGE=${ISO%*.iso}.usb
-    # leave 1 MB of free space on the filesystem
-    USB_KB=$(du -kc $ISO $CD_ROOT/usr/isolinux | awk '$2 == "total" { print $1 + 1024 }')
-    /sbin/mkfs.vfat -C $USB_IMAGE $USB_KB
+    echo "making USB image bootable."
+    syslinux "$usb"
+}
 
-    mkdir -p $INITRD_MOUNT
-    mount -o loop,rw $USB_IMAGE $INITRD_MOUNT
 
-    # populate the root of the image with the iso, pl_version, and the syslinux files
-    cp -a $ISO $INITRD_MOUNT
-    cp -a $CD_ROOT/usr/isolinux/{initrd.gz,kernel,message.txt,pl_version} $INITRD_MOUNT
-    cp -a $CD_ROOT/usr/isolinux/isolinux.cfg $INITRD_MOUNT/syslinux.cfg
+# Setup CRAMFS related support
+function prepare_cramfs()
+{
+    [ -n "$CRAMFS_PREPARED" ] && return 0
+    local console=$1; shift
+    local custom=$1; 
+    local serial=
+    if [ "$console" != "$GRAPHIC_CONSOLE" ] ; then
+       serial=1
+       console_dev=$(extract_console_dev $console)
+       console_baud=$(extract_console_baud $console)
+    fi
 
-    umount $INITRD_MOUNT
-    rmdir $INITRD_MOUNT
+    echo "* Setting up CRAMFS-based images"
+    local tmp="${BUILDTMP}/cramfs-tree"
+    mkdir -p "$tmp"
+    push_cleanup rm -rf $tmp
+    pushd $tmp
+    gzip -d -c $isofs/bootcd.img     | cpio -diu
+    gzip -d -c $isofs/overlay.img    | cpio -diu
+    [ -n "$custom" ] && \
+        gzip -d -c $isofs/custom.img | cpio -diu
+
+    # clean out unnecessary rpm lib
+    echo "* clearing var/lib/rpm/*"
+    rm -f var/lib/rpm/*
+
+    # bootcd requires this directory
+    mkdir -p mnt/confdevice
+
+    # relocate various directory to /tmp
+    rm -rf root
+    ln -fs /tmp/root root
+    ln -fs /sbin/init linuxrc 
+    ln -fs /tmp/resolv.conf etc/resolv.conf
+    ln -fs /tmp/etc/mtab etc/mtab
+
+    # have pl_rsysinit copy over appropriate etc & var directories into /tmp/etc/
+    # make /tmp/etc
+    echo "* renaming dirs in ./etc"
+    pushd etc
+    for dir in `find * -type d -prune | grep -v rc.d`; do
+        mv ${dir} ${dir}_o
+        ln -fs /tmp/etc/${dir} ${dir}
+    done
+    popd
 
-    # make it bootable
-    syslinux $USB_IMAGE
-}
+    echo "* renaming dirs in ./var"
+    # rename all top-level directories and put in a symlink to /tmp/var
+    pushd var
+    for dir in `find * -type d -prune`; do
+        mv ${dir} ${dir}_o
+        ln -fs /tmp/var/${dir} ${dir}
+    done
+    popd
 
-function burn()
-{
-    cdrecord $CDRECORD_FLAGS -data $ISO
-}
+    # overwrite fstab to mount / as cramfs and /tmp as tmpfs
+    echo "* Overwriting etc/fstab to use cramfs and tmpfs"
+    rm -f ./etc/fstab
+    cat >./etc/fstab <<EOF
+/dev/ram0     /              cramfs     ro              0 0
+none          /dev/pts       devpts     gid=5,mode=620  0 0
+none          /proc          proc       defaults        0 0
+none          /sys           sysfs      defaults        0 0
+EOF
 
-function clean()
-{
-    rm -rf $CD_ROOT
-    rm -rf $BUILD_DIR/syslinux
-    rm -rf $BUILD_DIR/$INITRD_MOUNT
-    rm -rf $BUILD_DIR
-    rm -f $ISO
-    rmdir --ignore-fail-on-non-empty build
-}
+    pushd dev
+    rm -f console
+    mknod console c 5 1
+    #for i in 0 1 2 3 4 5 6 7 8; do rm -f ram${i} ; done
+    #for i in 0 1 2 3 4 5 6 7 8; do mknod ram${i} b 1 ${i} ; done
+    #ln -fs ram1 ram
+    #ln -fs ram0 ramdisk
+    popd
 
-if [[ "$1" == "clean" || "$1" == "burn" || "$1" == "build" ]]; then
-    action=$1
-    configuration=$2
+    # update etc/inittab to start with pl_rsysinit
+    sed -i 's,pl_sysinit,pl_rsysinit,' etc/inittab
 
-    if [[ -z "$configuration" ]]; then
-       configuration=default
+    # modify inittab to have a serial console
+    if [ -n "$serial" ] ; then
+       echo "T0:23:respawn:/sbin/agetty -L $console_dev $console_baud vt100" >> etc/inittab
+        # and let root log in
+       echo "$console_dev" >> etc/securetty
     fi
 
-    echo "Loading configuration $configuration"
-    CURRENT_CONFIG_DIR=$CONFIGURATIONS_DIR/$configuration
-    . $CURRENT_CONFIG_DIR/configuration
+    # calculate the size of /tmp based on the size of /etc & /var + 8MB slack
+    etcsize=$(du -s ./etc | awk '{ print $1 }')
+    varsize=$(du -s ./var | awk '{ print $1 }')
+    let msize=($varsize+$etcsize+8192)/1024
+
+    # make dhclient happy
+    for i in $(seq 0 9); do ln -fs /tmp/etc/dhclient-eth${i}.conf etc/dhclient-eth${i}.conf ; done
+    ln -fs /tmp/etc/resolv.conf etc/resolv.conf
+    ln -fs /tmp/etc/resolv.conf.predhclient etc/resolv.conf.predhclient
+
+    # generate pl_rsysinit
+    cat > etc/rc.d/init.d/pl_rsysinit <<EOF
+#!/bin/sh
+# generated by build.sh
+echo -n "pl_rsysinit: preparing /etc and /var for pl_sysinit..."
+mount -t tmpfs -orw,size=${msize}M,mode=1777 tmpfs /tmp
+mkdir -p /tmp/root
+mkdir -p /tmp/etc
+touch /tmp/etc/resolv.conf
+touch /tmp/etc/mtab
+mkdir -p /tmp/var
+
+# make mtab happy
+echo "tmpfs /tmp tmpfs rw,size=${msize}M,mode=1777 1 1" > /tmp/etc/mtab
+
+# copy over directory contents of all _o directories from /etc and /var
+# /tmp/etc and /tmp/var
+pushd /etc
+for odir in \$(cd /etc && ls -d *_o); do dir=\$(echo \$odir | sed 's,\_o$,,'); (mkdir -p /tmp/etc/\$dir && cd \$odir && find . | cpio -p -d -u /tmp/etc/\$dir); done
+popd
+pushd /var
+for odir in \$(cd /var && ls -d *_o); do dir=\$(echo \$odir | sed 's,\_o$,,'); (mkdir -p /tmp/var/\$dir && cd \$odir && find . | cpio -p -d -u /tmp/var/\$dir); done
+popd
+
+echo "done"
+
+# hand over to pl_sysinit
+echo "pl_rsysinit: handing over to pl_sysinit"
+/etc/init.d/pl_sysinit
+EOF
+    chmod +x etc/rc.d/init.d/pl_rsysinit
+
+    popd
 
-    # setup vars for this configuration
+    # create the cramfs image
+    echo "* Creating cramfs image"
+    mkfs.cramfs $tmp/ ${BUILDTMP}/cramfs.img
+    cramfs_size=$(($(du -sk ${BUILDTMP}/cramfs.img | awk '{ print $1; }') + 1))
+    rm -rf $tmp
+    pop_cleanup
+}
 
-    # version string for this build
-    if [[ ! -z "$EXTRA_VERSION" ]]; then
-       FULL_VERSION_STRING="$FULL_VERSION_STRING $EXTRA_VERSION"
+# Create ISO CRAMFS image
+function build_iso_cramfs()
+{
+    local iso="$1" ; shift
+    local console="$1" ; shift
+    local custom="$1"
+    local serial=
+
+    if [ "$console" != "$GRAPHIC_CONSOLE" ] ; then
+       serial=1
+       console_dev=$(extract_console_dev $console)
+       console_baud=$(extract_console_baud $console)
+       console_parity=$(extract_console_parity $console)
+       console_bits=$(extract_console_bits $console)
     fi
-    FULL_VERSION_STRING="$FULL_VERSION_STRING $BOOTCD_VERSION"
+    prepare_cramfs "$console" "$custom"
+    echo "* Creating ISO CRAMFS-based image"
+
+    local tmp="${BUILDTMP}/cramfs-iso"
+    mkdir -p "$tmp"
+    push_cleanup rm -rf $tmp
+    (cd $isofs && find . | grep -v "\.img$" | cpio -p -d -u $tmp/)
+    cat >$tmp/isolinux.cfg <<EOF
+${serial:+SERIAL 0 $console_baud}
+DEFAULT kernel
+APPEND ramdisk_size=$cramfs_size initrd=cramfs.img root=/dev/ram0 ro ${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
+DISPLAY pl_version
+PROMPT 0
+TIMEOUT 40
+EOF
 
-    # destination image
-    if [[ ! -z "$EXTRA_VERSION" ]]; then
-       OUTPUT_IMAGE_NAME="$OUTPUT_IMAGE_NAME-$EXTRA_VERSION"
+    # write kargs.txt with additional args that should be executed by kexec to production mode
+    cat >$tmp/kargs.txt <<EOF
+${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
+EOF
+
+    cp ${BUILDTMP}/cramfs.img $tmp
+    mkisofs -o "$iso" \
+        $MKISOFS_OPTS \
+        $tmp
+
+    rm -fr "$tmp"
+    pop_cleanup
+}
+
+# Create USB CRAMFS based image
+function build_usb_cramfs()
+{
+    local usb="$1" ; shift
+    local console="$1" ; shift
+    local custom="$1"
+    local serial=
+
+    if [ "$console" != "$GRAPHIC_CONSOLE" ] ; then
+       serial=1
+       console_dev=$(extract_console_dev $console)
+       console_baud=$(extract_console_baud $console)
+       console_parity=$(extract_console_parity $console)
+       console_bits=$(extract_console_bits $console)
     fi
-    OUTPUT_IMAGE_NAME="$OUTPUT_IMAGE_NAME-$BOOTCD_VERSION"
+    prepare_cramfs "$console" "$custom"
+    echo "* Creating USB CRAMFS based image"
 
-    # setup build directories
-    BUILD_DIR=build/$configuration
-    mkdir -p $BUILD_DIR
-    ISO=$BUILD_DIR/`echo $OUTPUT_IMAGE_NAME | sed -e "s/%version/$BOOTCD_VERSION/"`.iso
+    let vfat_size=${cramfs_size}+$FREE_SPACE
 
-    CD_ROOT=`pwd`/$BUILD_DIR/cdroot
-    mkdir -p $CD_ROOT
+    # Make VFAT filesystem for USB
+    mkfs.vfat -C "$usb" $vfat_size
 
-    # location of the uncompressed ramdisk image
-    INITRD=$CD_ROOT/usr/isolinux/initrd
+    # write kargs.txt with additional args that should be executed by kexec to production mode
+    tmp="${BUILDTMP}/kargs.txt"
+    cat >$tmp <<EOF
+${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
+EOF
+    mcopy -i "$usb" "$tmp" ::/kargs.txt
+    rm -f "$tmp"
+
+    # Populate it
+    echo "* Populating USB with overlay images and cramfs"
+    mcopy -bsQ -i "$usb" $isofs/kernel $isofs/pl_version ::/
+    mcopy -bsQ -i "$usb" ${BUILDTMP}/cramfs.img ::/
+
+    # Use syslinux instead of isolinux to make the image bootable
+    tmp="${BUILDTMP}/syslinux.cfg"
+    cat >$tmp <<EOF
+${serial:+SERIAL 0 $console_baud}
+DEFAULT kernel
+APPEND ramdisk_size=$cramfs_size initrd=cramfs.img root=/dev/ram0 ro ${serial:+console=${console_dev},${console_baud}${console_parity}${console_bits}}
+DISPLAY pl_version
+PROMPT 0
+TIMEOUT 40
+EOF
 
-    # temporary mount point for rd
-    INITRD_MOUNT=`pwd`/$BUILD_DIR/rd
+    mcopy -bsQ -i "$usb" "$tmp" ::/syslinux.cfg
+    rm -f "$tmp"
 
+    echo "* Making USB CRAMFS based image bootable"
+    syslinux "$usb"
+}
 
-    case $action in 
-       build )
-           echo "Proceeding with building $DESCRIPTION"
-           build;;
+function type_to_name()
+{
+    echo $1 | sed '
+        s/usb$/.usb/;
+        s/usb_partition$/-partition.usb/;
+        s/iso$/.iso/;
+        s/usb_cramfs$/-cramfs.usb/;
+        s/iso_cramfs$/-cramfs.iso/;
+        '
+}
 
-       clean )
-           echo "Removing built files for $DESCRIPTION"
-           clean;;
+[ -z "$OUTPUT_BASE" ] && OUTPUT_BASE="$PLC_NAME-BootCD-$BOOTCD_VERSION"
+
+for t in $TYPES; do
+    arg=$t
+    console=$CONSOLE_INFO
+
+    # figure if this is a serial image (can be specified in the type or with -s)
+    if  [[ "$t" == *serial* || "$console" != "$GRAPHIC_CONSOLE" ]]; then
+       # remove serial from type
+       t=`echo $t | sed 's/_serial//'`
+       # check console
+       [ "$console" == "$GRAPHIC_CONSOLE" ] && console="$SERIAL_CONSOLE"
+       # compute filename part
+       if [ "$console" == "$SERIAL_CONSOLE" ] ; then
+           serial="-serial"
+       else
+           serial="-serial-$(echo $console | sed -e 's,:,,g')"
+       fi
+    else
+       serial=""
+    fi
+    
+    tname=`type_to_name $t`
+    # if -o is specified (as it has no default)
+    if [ -n "$OUTPUT_NAME" ] ; then
+       output=$OUTPUT_NAME
+    else
+       output="${OUTPUT_BASE}${serial}${tname}"
+    fi
 
-       burn )
-           echo "Burning $DESCRIPTION"
-           burn;;
-    esac    
-else
-    usage
-fi
+    echo "*** Dealing with type=$arg"
+    echo '*' build_$t "$output" "$console" "$CUSTOM_DIR"
+    if [ ! -n "$DRY_RUN" ] ; then
+       build_$t "$output" "$console" "$CUSTOM_DIR" 
+    fi
+done
 
+exit 0